<?php

namespace FiloBlu\GuestWishlist\Model\Plugin;

class Wishlist {

    protected $guestWishlistFactory;
    protected $_helper;

    public function __construct(
    \FiloBlu\GuestWishlist\Model\WishlistFactory $guestWishlistFactory, \FiloBlu\GuestWishlist\Helper\Data $helper
    ) {
        $this->_helper = $helper;
        $this->guestWishlistFactory = $guestWishlistFactory;
    }

    public function beforeLoadByCustomerId(\Magento\Wishlist\Model\Wishlist $wishlistModel, $customerId, $create = false) {
        
        # Guest become customer and keep old guest wishlist
        if ($this->_helper->getConfig("general/enabled") && $customerId && $create && $this->_helper->getCookie()) {
            $customerId = (int) $customerId;
            $customerIdFieldName = $wishlistModel->getResource()->getCustomerIdFieldName();
            $wishlistModel->getResource()->load($wishlistModel, $customerId, $customerIdFieldName);
            if (!$wishlistModel->getId()) {
                $wishlist = $this->guestWishlistFactory->create();
                $wishlistTocustomer = $wishlist->loadByCookie();
                $wishlistTocustomer->setCustomerId($customerId);
                $wishlistTocustomer->setCookie(NULL);
                $wishlistTocustomer->save();
                
                $this->_helper->setCookie(NULL);
            }
        }
        
        return array($customerId,$create);
    }

}
